<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  admin_articles.php                                       ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/tree.php");

	check_admin_security("articles");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_articles.html");

	// set files names
	$t->set_var("admin_articles_top_href", "admin_articles_top.php");
	$t->set_var("admin_article_href", "admin_article.php");
	$t->set_var("admin_articles_href", "admin_articles.php");
	$t->set_var("admin_articles_category_href", "admin_articles_category.php");
	$t->set_var("admin_layout_page_href", "admin_layout_page.php");
	$t->set_var("admin_reviews_href", "admin_reviews.php");
	$t->set_var("admin_tell_friend_href", "admin_tell_friend.php");


	$t->set_var("admin_articles_assign_href", "admin_articles_assign.php");
	$t->set_var("admin_articles_categories_href", "admin_articles_categories.php");
	$t->set_var("admin_article_related_href", "admin_article_related.php");
	$t->set_var("admin_articles_order_href",  "admin_articles_order.php");
	$t->set_var("admin_articles_assign_href", "admin_articles_assign.php");

	include("./admin_header.php");
	include("./admin_footer.php");

	$category_id = get_param("category_id"); 
	$top_category_id = 0;
	if (!strlen($category_id)) {
		header("Location: admin.php");
		exit;
	} else {
		$sql  = " SELECT category_path,parent_category_id ";
		$sql .= " FROM " . $table_prefix . "articles_categories ";
		$sql .= " WHERE category_id=" . $db->tosql($category_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$parent_category_id = $db->f("parent_category_id");
			$category_path = $db->f("category_path");
			if($parent_category_id == 0) {
				$top_category_id = $category_id;
			} else {
				$categories_ids = explode(",", $category_path);
				$top_category_id = $categories_ids[1];
			}
		}
	}

	$articles_order_column = ""; $articles_order_direction = ""; $top_category_name = "";
	$sql  = " SELECT category_name, articles_order_column,articles_order_direction ";
	$sql .= " FROM " . $table_prefix . "articles_categories ";
	$sql .= " WHERE category_id=" . $db->tosql($top_category_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		$top_category_name = get_translation($db->f("category_name"));
		$articles_order_column = $db->f("articles_order_column");
		$articles_order_direction = $db->f("articles_order_direction");
	}
	$t->set_var("top_category_name", $top_category_name);
	$t->set_var("top_category_id", $top_category_id);

	// get search parameters
	$s = trim(get_param("s"));
	$sc = get_param("sc");
	$search = strlen($s) ? true : false;
	if($search && $sc) { $category_id = $sc; }
	$sa = "";

	$t->set_var("category_id", $category_id);

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "articles_categories", "tree", "");
	$tree->show($category_id);

	$sql  = " SELECT full_description FROM " . $table_prefix . "articles_categories WHERE category_id = " . $db->tosql($category_id, INTEGER);
	$db->query($sql);
	if($db->next_record())
		$t->set_var("full_description", $db->f("full_description"));
	else
		$t->set_var("full_description", "");

	$sql  = " SELECT category_id, category_name ";
	$sql .= " FROM " . $table_prefix . "articles_categories WHERE parent_category_id = " . $db->tosql($category_id, INTEGER);
	$sql .= " ORDER BY category_order ";
	$db->query($sql);
	if($db->next_record())
	{
		$t->parse("categories_order_link", false);
		$t->set_var("no_categories", "");
		do
		{
			$t->set_var("row_category_id", $db->f("category_id"));
			$t->set_var("category_name", get_translation($db->f("category_name")));
			$t->parse("articles_categories");
		} while ($db->next_record());
		$t->parse("categories_header", false);
	}
	else
	{
		$t->set_var("articles_categories", "");
		$t->set_var("categories_order_link", "");
		$t->parse("no_categories");
	}

	$sql  = " SELECT a.article_id, a.article_title, aa.category_id, st.status_name, st.allowed_view ";
	$sql .= " FROM (((" . $table_prefix . "articles a ";
	$sql .= " INNER JOIN " . $table_prefix . "articles_assigned aa ON a.article_id=aa.article_id) ";
	$sql .= " INNER JOIN " . $table_prefix . "articles_categories ac ON ac.category_id = aa.category_id)";
	$sql .= " LEFT JOIN " . $table_prefix . "articles_statuses st ON a.status_id=st.status_id) ";
	if($search) {
		$sql .= " WHERE (aa.category_id = " . $db->tosql($category_id, INTEGER);
		$sql .= " OR c.category_path LIKE '" . $db->tosql($tree->get_path($category_id), TEXT, false) . "%')";
	} else if(!$search) {
		$sql .= " WHERE aa.category_id = " . $db->tosql($category_id, INTEGER);
	}
	if($search) {
		$sa = split(" ", $s);
		for($si = 0; $si < sizeof($sa); $si++) {
			$sql .= " AND a.article_title LIKE '%" . $db->tosql($sa[$si], TEXT, false) . "%'";
		}
	}
	$sql .= " GROUP BY a.article_id, a.article_date, st.status_name, st.allowed_view, a.date_end, a.article_title, a.author_name, aa.category_id, a.article_order, a.date_added, a.date_updated ";
	if ($articles_order_column) {
		$sql .= " ORDER BY a." . $articles_order_column . " " . $articles_order_direction;
	} else {
		$sql .= " ORDER BY a.article_order ";
	}

	$db->query($sql);
	if($db->next_record())
	{
		$t->parse("articles_order_link", false);
		$t->set_var("no_items", "");
		do
		{
			$article_id = $db->f("article_id");
			$article_title = get_translation($db->f("article_title"));
			$article_status = $db->f("status_name");
			$allowed_view = $db->f("allowed_view");
			if ($allowed_view == 0) {
				$status_color = "silver";
			} else if ($allowed_view == 1) {
				$status_color = "blue"; 
			} else {
				$status_color = "black";
			}
			$article_status = "<font color=\"" . $status_color . "\">" . $article_status . "</font>";


			$t->set_var("article_category_id", $db->f("category_id"));
			$t->set_var("article_id", $db->f("article_id"));
			if($search) {
				for($si = 0; $si < sizeof($sa); $si++) {
					$article_title = preg_replace ("/(" . $sa[$si] . ")/i", "<b>\\1</b>", $article_title);					
				}
			}
			$t->set_var("article_title", $article_title);
			$t->set_var("article_status", $article_status);
			$t->parse("items_list");
		} while ($db->next_record());
		$t->parse("items_header", false);
	}
	else
	{
		$t->set_var("articles_order_link", "");
		$t->set_var("items_list", "");
		$t->parse("no_items");
	}

	// set up search form parameters
	$values_before[] = array($top_category_id, "All Categories");
	if($category_id != 0) {
		$values_before[] = array($category_id, "Current Category");
	}

	$sql  = " SELECT category_id, category_name ";
	$sql .= " FROM " . $table_prefix . "articles_categories WHERE parent_category_id = " . $db->tosql($category_id, INTEGER);
	$sql .= " ORDER BY category_order ";
	$sc_values = get_db_values($sql, $values_before);

	set_options($sc_values, $sc, "sc");
	$t->set_var("s", $s);
	if($search) {
		$t->parse("s_d", false);
	}

	$t->parse("items_block", false);

	$t->pparse("main");

?>