<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  admin_order_item.php                                     ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/editgrid.php");
	include($root_folder_path . "includes/order_items.php");
	include($root_folder_path . "includes/date_functions.php");

	check_admin_security("sales_orders");
	check_admin_security("update_orders");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_order_item.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_order_href", "admin_order.php");
	$t->set_var("admin_orders_href", "admin_orders.php");
	$t->set_var("admin_order_item_href", "admin_order_item.php");
	
	$order_id = get_param("order_id");
	$order_item_id = get_param("order_item_id");
	$default_status = "";
	if ($order_item_id) {
		$sql  = " SELECT order_id,item_name FROM " . $table_prefix . "orders_items ";
		$sql .= " WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER);
		$db->query($sql);
		if($db->next_record()) {
			$order_id = $db->f("order_id");
		} else {
			$order_id = "";
		}
	} else if ($order_id) {
		$sql  = " SELECT order_id,order_status FROM " . $table_prefix . "orders ";
		$sql .= " WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if($db->next_record()) {
			$order_id = $db->f("order_id");
			$default_status = $db->f("order_status");
		} else {
			$order_id = "";
		}
	}

	if (!$order_id) {
		die("There is no such product in the orders list.");
	}


	// set up html form parameters

	$r = new VA_Record($table_prefix . "orders_items");
	$r->add_where("order_item_id", INTEGER);
	$r->change_property("order_item_id", USE_IN_INSERT, true);
	$r->add_hidden("order_id", INTEGER);
	$r->change_property("order_id", USE_IN_INSERT, true);
	$r->add_hidden("item_id", INTEGER);
	$r->change_property("item_id", USE_IN_INSERT, true);
	$item_types = get_db_values("SELECT * FROM " . $table_prefix . "item_types", array(array("", "")));
	$r->add_select("item_type_id", INTEGER, $item_types, "Type");
	$r->change_property("item_type_id", REQUIRED, true);
	$r->add_textbox("manufacturer_code", TEXT);
	//$r->add_textbox("coupons_ids", TEXT);
	$order_statuses = get_db_values("SELECT * FROM " . $table_prefix . "order_statuses", array(array("", "")));
	$r->add_select("item_status", INTEGER, $order_statuses, "Status");
	$r->change_property("item_status", REQUIRED, true);
	$r->add_textbox("item_name", TEXT, "Product Name");
	$r->change_property("item_name", REQUIRED, true);
	//$r->add_textbox("item_properties", TEXT);
	$r->add_textbox("buying_price", FLOAT);
	//$r->add_textbox("real_price", FLOAT);
	//$r->add_textbox("discount_amount", FLOAT);
	$r->add_textbox("price", FLOAT, "Selling Price");
	$r->change_property("price", REQUIRED, true);
	$r->add_textbox("tax_percent", FLOAT, "Tax Percent");
	$r->add_checkbox("tax_free", INTEGER);
	$r->add_textbox("weight", FLOAT);
	$r->add_textbox("quantity", INTEGER, "Quantity");
	$r->change_property("quantity", REQUIRED, true);
	$r->add_checkbox("downloadable", INTEGER);

	$r->get_form_values();
	$r->set_value("order_id", $order_id);

	$ipv = new VA_Record($table_prefix . "orders_items_properties", "properties");
	$ipv->add_where("item_property_id", INTEGER);
	$ipv->add_hidden("order_id", INTEGER);
	$ipv->change_property("order_id", USE_IN_INSERT, true);
	$ipv->add_hidden("order_item_id", INTEGER);
	$ipv->change_property("order_item_id", USE_IN_INSERT, true);
	$ipv->add_hidden("property_id", INTEGER);
	$ipv->change_property("property_id", USE_IN_INSERT, true);
	$ipv->add_textbox("property_name", TEXT, "Property Name");
	$ipv->change_property("property_name", REQUIRED, true);
	$ipv->add_textbox("property_value", TEXT, "Property Value");
	$ipv->change_property("property_value", REQUIRED, true);
	$ipv->add_textbox("additional_price", NUMBER, "Additional Price");
	$ipv->add_textbox("additional_weight", NUMBER, "Additional Weight");

	$property_id = get_param("property_id");
	$order_item_id = get_param("order_item_id");

	$more_properties = get_param("more_properties");
	$number_properties = get_param("number_properties");

	$eg = new VA_EditGrid($ipv, "properties");
	$eg->get_form_values($number_properties);

	$operation = get_param("operation");

	$return_page = "admin_order.php?order_id=" . $order_id;

	if(strlen($operation) && !$more_properties)
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $order_item_id)
		{
			$db->query("DELETE FROM " . $table_prefix . "orders_items WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER));		
			$db->query("DELETE FROM " . $table_prefix . "orders_items_properties WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER));		
			header("Location: " . $return_page);
			exit;
		}

		$is_valid = $r->validate();
		$is_valid = ($eg->validate() && $is_valid); 

		if($is_valid)
		{
			if(strlen($order_item_id))
			{
				$r->update_record();
				$eg->set_values("order_item_id", $order_item_id);
				$eg->set_values("order_id", $order_id);
				$eg->set_values("property_id", 0);
				$eg->update_all($number_properties);
			}
			else
			{
				$db->query("SELECT MAX(order_item_id) FROM " . $table_prefix . "orders_items");
				$db->next_record();
				$order_item_id = $db->f(0) + 1;
				$r->set_value("order_item_id", $order_item_id);
				$r->insert_record();
				$eg->set_values("order_item_id", $order_item_id);
				$eg->set_values("order_id", $order_id);
				$eg->set_values("property_id", 0);
				$eg->insert_all($number_properties);
			}
			update_order_items($order_id);
			$item_properties = "";
			$sql  = " SELECT property_name, property_value FROM " . $table_prefix . "orders_items_properties ";
			$sql .= " WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER);
			$db->query($sql);
			while ($db->next_record()) {
				$property_name = get_translation($db->f("property_name"));
				$property_value = get_translation($db->f("property_value"));
				$item_properties .= "<br>" . $property_name . ": " . $property_value;
			}
			$sql  = " UPDATE " . $table_prefix . "orders_items ";
			$sql .= " SET item_properties=" . $db->tosql($item_properties, TEXT);
			$sql .= " WHERE order_item_id=" . $db->tosql($order_item_id, INTEGER);
			$db->query($sql);

			// add event
			$oe = new VA_Record($table_prefix . "orders_events");
			$oe->add_textbox("order_id", INTEGER);
			$oe->add_textbox("status_id", INTEGER);
			$oe->add_textbox("admin_id", INTEGER);
			$oe->add_textbox("event_date", DATETIME);
			$oe->add_textbox("event_name", TEXT);
			$oe->add_textbox("event_description", TEXT);
			$oe->set_value("order_id", $order_id);
			$oe->set_value("status_id", 0);
			$oe->set_value("admin_id", get_session("session_admin_id"));
			$oe->set_value("event_date", va_time());
			$oe->set_value("event_name", "Update Product");
			$oe->set_value("event_description", $r->get_value("item_name"));
			$oe->insert_record();

			header("Location: " . $return_page);
			exit;
		}
	}
	else if(strlen($order_item_id) && !$more_properties)
	{
		$r->get_db_values();
		$eg->set_value("order_item_id", $order_item_id);
		$eg->change_property("item_property_id", USE_IN_SELECT, true);
		$eg->change_property("item_property_id", USE_IN_WHERE, false);
		$eg->change_property("order_item_id", USE_IN_WHERE, true);
		$eg->change_property("order_item_id", USE_IN_SELECT, true);
		$number_properties = $eg->get_db_values();
		if($number_properties == 0)
			$number_properties = 5;
	}
	else if($more_properties)
	{
		$number_properties += 5;
	}
	else // set default values
	{
		$r->set_value("order_id", $order_id);
		$r->set_value("item_status", $default_status);
		$number_properties = 5;
	}

/*
	if(strlen($errors))
	{
		$t->set_var("errors_list", $errors);
		$t->parse("errors", false);
	}
	else
	{
		$t->set_var("errors", "");
	}
*/

	$t->set_var("number_properties", $number_properties);

	$eg->set_parameters_all($number_properties);
	$r->set_parameters();

	if(strlen($order_item_id))	
	{
		$t->set_var("save_button", " Update ");
		$t->parse("delete", false);	
	}
	else
	{
		$t->set_var("save_button", "Add Product");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>