<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  block_articles_list.php                                  ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/
                           

function articles_list($block_name, $top_id, $list_fields, $articles_order, $current_category, $list_template)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings, $restrict_articles_images;
	global $category_id;
	global $datetime_show_format;
	global $sc_item_id, $sc_category_id, $item_added, $sc_errors;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	if (!strlen($list_template)) { $list_template = "block_articles_list.html"; }

	$t->set_file("block_body",      $list_template);
	$t->set_var("NO_ARTICLES_MSG",  NO_ARTICLES_MSG);
	$t->set_var("TOP_CATEGORY_MSG", TOP_CATEGORY_MSG);
	$t->set_var("MORE_MSG",         MORE_MSG);
	$t->set_var("READ_MORE_MSG",    READ_MORE_MSG);
	$t->set_var("CLICK_HERE_MSG",   CLICK_HERE_MSG);
	$t->set_var("RATING_MSG",       RATING_MSG);
	$t->set_var("FOUND_IN_MSG",     FOUND_IN_MSG);
	$t->set_var("LINK_URL_MSG",     LINK_URL_MSG);
	$t->set_var("DOWNLOAD_URL_MSG", DOWNLOAD_URL_MSG);
	$t->set_var("NOTES_MSG",        NOTES_MSG);
	$t->set_var("KEYWORDS_MSG",     KEYWORDS_MSG);

	$category_id = get_param("category_id");
	$search_category_id = get_param("search_category_id");
	$search_string = trim(get_param("search_string"));
	$s_tit = get_param("s_tit");
	$s_sds = get_param("s_sds");
	$s_fds = get_param("s_fds");
	$page = get_param("page");
	$is_search = (strlen($search_string));

	if(strlen($search_category_id)) {
		$category_id = $search_category_id;
	}
	if(!strlen($category_id)) $category_id = "0";

	$t->set_var("details_href",  "article.php");
	$t->set_var("reviews_href",  "articles_reviews.php");
	
	$pass_parameters = array(
		"category_id" => $category_id, "search_string" => $search_string,
		"search_category_id" => $search_category_id
	);

	$t->set_var("current_category_name", htmlspecialchars($current_category));

	$search_tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "articles_categories", "tree", "");

	$sql  = " SELECT COUNT(*) FROM (((" . $table_prefix . "articles a ";
	$sql .= " INNER JOIN " . $table_prefix . "articles_statuses st ON a.status_id=st.status_id) ";
	$sql .= " INNER JOIN " . $table_prefix . "articles_assigned aa ON a.article_id=aa.article_id) ";
	$sql .= " INNER JOIN " . $table_prefix . "articles_categories ac ON ac.category_id = aa.category_id)";
	$sql_where  = " WHERE st.allowed_view=1 ";
	if ($is_search)	{
		$sql_where .= " AND (aa.category_id = " . $db->tosql($search_category_id, INTEGER);
		$sql_where .= " OR ac.category_path LIKE '" . $db->tosql($search_tree->get_path($search_category_id), TEXT, false) . "%')";
	} else if(!$is_search) {
		$sql_where .= " AND aa.category_id = " . $db->tosql($category_id, INTEGER);
	}
	if (strlen($search_string)) {
		$search_values = split(" ", $search_string);
		for($si = 0; $si < sizeof($search_values); $si++) {
			$s_fields = 0;
			$sql_where .= " AND ( ";
			if ($s_sds == 1) {
				$s_fields++;
				$sql_where .= " a.short_description LIKE '%" . $db->tosql($search_values[$si], TEXT, false) . "%'";
			}
			if ($s_fds == 1) {
				if ($s_fields > 0) {$sql_where .= " OR ";}
				$s_fields++;
				$sql_where .= " a.full_description LIKE '%" . $db->tosql($search_values[$si], TEXT, false) . "%'";
			}
			if ($s_tit == 1 || $s_fields == 0) {
				if ($s_fields > 0) {$sql_where .= " OR ";}
				$s_fields++;
				$sql_where .= " a.article_title LIKE '%" . $db->tosql($search_values[$si], TEXT, false) . "%'";
			}
			$sql_where .= " ) ";
		}
	}
	$db->query($sql . $sql_where);
	$db->next_record();
	$total_records = $db->f(0);

	// set up variables for navigator
	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", "articles.php");

	$records_per_page = get_setting_value($page_settings, "a_list_recs_" . $top_id, 10);
	$pages_number = 5;
	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false, $pass_parameters);
	$total_pages = ceil($total_records / $records_per_page);

	// generate page link with query parameters
	$pass_parameters["page"] = $page;
	$query_string = get_query_string($pass_parameters, "", "", true);
	$rp = "articles.php";
	$rp	.= $query_string;

	$t->set_var("rp_url", urlencode($rp));
	$t->set_var("rp", htmlspecialchars($rp));
	$t->set_var("total_records", $total_records);
	$t->set_var("search_string", htmlspecialchars($search_string));

	$list_fields = ",," . $list_fields . ",,";

	$article_fields = array(
		"author_name", "author_email", "author_url", "link_url", "download_url", 
		"short_description", "full_description", "keywords", "notes"
	);

	$sql  = " SELECT a.article_id, a.article_title, a.article_date, a.date_end, ";
	$sql .= " a.author_name, a.author_email, a.author_url, a.link_url, a.download_url, ";
	$sql .= " a.short_description, a.is_html, a.full_description, ";
	$sql .= " a.image_small,  a.image_small_alt, a.image_large, a.image_large_alt, ";
	$sql .= " a.rating, aa.category_id, ac.category_name, a.allowed_rate, ";
	$sql .= " a.keywords, a.notes ";
	$sql .= " FROM (((" . $table_prefix . "articles a ";
	$sql .= " INNER JOIN " . $table_prefix . "articles_statuses st ON a.status_id=st.status_id) ";
	$sql .= " INNER JOIN " . $table_prefix . "articles_assigned aa ON a.article_id=aa.article_id) ";
	$sql .= " INNER JOIN " . $table_prefix . "articles_categories ac ON ac.category_id = aa.category_id)";
	$sql .= $sql_where;
	$sql .= $articles_order;

	$t->set_var("category_id", htmlspecialchars($category_id));
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$db->query($sql);
	if($db->next_record())
	{
		$columns = get_setting_value($page_settings, "a_list_cols_" . $top_id, 1);
		$t->set_var("item_column", (100 / $columns) . "%");
		$t->set_var("total_columns", $columns);
		$item_number = 0;
		do
		{
			$item_number++;
			$article_id = $db->f("article_id");
			$ic_id      = $db->f("category_id");
			$article_category = get_translation($db->f("category_name"));
			$a_name = $ic_id . "_" . $article_id;
			$article_title = get_translation($db->f("article_title"));

			$t->set_var("article_id", $article_id);
			$t->set_var("ic_id", $ic_id);
			if ($is_search) {
				$t->set_var("article_category", $article_category);
				$t->global_parse("found_in_category", false, false, true);
			} else {
				$t->set_var("found_in_category", "");
			}
			$t->set_var("a_name", $a_name);
			$t->set_var("article_title", $article_title);

			// get fields values
			$article_date_string = ""; $date_end_string = "";
			if (strpos($list_fields, ",article_date,")) {
				$article_date = $db->f("article_date", DATETIME);
				$article_date_string  = va_date($datetime_show_format, $article_date);
				$t->set_var("article_date", $article_date_string);
				$t->global_parse("article_date_block", false, false, true);
			} else {
				$t->set_var("article_date_block", "");
			}
			if (strpos($list_fields, ",date_end,")) {
				$date_end = $db->f("date_end", DATETIME);
				$date_end_string = va_date($datetime_show_format, $date_end);
				$t->set_var("date_end", $date_end_string);
				$t->global_parse("date_end_block", false, false, true);
			} else {
				$t->set_var("date_end_block", "");
			}
			if (strlen($article_date_string) || strlen($date_end_string)) {
				$t->global_parse("date_block", false, false, true);
			}

			for ($i = 0; $i < sizeof($article_fields); $i++) {
				$field_name = $article_fields[$i];
				$fields[$field_name] = get_translation($db->f($field_name));
				if (strlen($fields[$field_name]) && strpos($list_fields, "," . $field_name . ",")) {
					$t->set_var($field_name, $fields[$field_name]);
					$t->global_parse($field_name . "_block", false, false, true);
				} else {
					$fields[$field_name] = "";
					$t->set_var($field_name, "");
					$t->set_var($field_name . "_block", "");
				}
			}

			if(strlen($fields["author_name"]) || strlen($fields["author_email"]) || strlen($fields["author_url"])) {
				$t->global_parse("author_block", false, false, true);
			} else {
				$t->set_var("author_block", false);
			}

			if (strpos($list_fields, ",full_description,")) {
				$full_description = get_translation($db->f("full_description"));
				if ($db->f("is_html") != 1) {
					$full_description = nl2br(htmlspecialchars($full_description));
				}
				$t->set_var("full_description", $full_description);
			} else {
				$t->set_var("full_description", "");
			}

			$image_small = $db->f("image_small");
			$image_small_alt = $db->f("image_small_alt");
			if (strpos($list_fields, ",image_small,") && strlen($image_small)) {
				if (preg_match("/^http\:\/\//", $image_small)) {
					$image_size = "";
				} else {
	        $image_size = @GetImageSize($image_small);
					if (isset($restrict_articles_images) && $restrict_articles_images) { $image_small = "image_show.php?article_id=".$article_id."&type=small"; }
				}
				if (!strlen($image_small_alt)) { $image_small_alt = $article_title; }
        $t->set_var("alt", htmlspecialchars($image_small_alt));
        $t->set_var("src", htmlspecialchars($image_small));
				if(is_array($image_size)) {
	        $t->set_var("width", "width=\"" . $image_size[0] . "\"");
  	      $t->set_var("height", "height=\"" . $image_size[1] . "\"");
				} else {
	        $t->set_var("width", "");
  	      $t->set_var("height", "");
				}
				$t->global_parse("image_small_block", false, false, true);
			} else {
				$t->set_var("image_small_block", "");
			}

			$image_large = $db->f("image_large");
			$image_large_alt = $db->f("image_large_alt");
			if (strpos($list_fields, ",image_large,") && strlen($image_large)) {
				if (preg_match("/^http\:\/\//", $image_large)) {
					$image_size = "";
				} else {
	        $image_size = @GetImageSize($image_large);
					if (isset($restrict_articles_images) && $restrict_articles_images) { $image_large = "image_show.php?article_id=".$article_id."&type=large"; }
				}
				if (!strlen($image_large_alt)) { $image_large_alt = $article_title; }
        $t->set_var("alt", htmlspecialchars($image_large_alt));
        $t->set_var("src", htmlspecialchars($image_large));
				if(is_array($image_size)) {
	        $t->set_var("width", "width=\"" . $image_size[0] . "\"");
  	      $t->set_var("height", "height=\"" . $image_size[1] . "\"");
				} else {
	        $t->set_var("width", "");
  	      $t->set_var("height", "");
				}
				$t->global_parse("image_large_block", false, false, true);
			} else {
				$t->set_var("image_large_block", "");
			}

			$allowed_rate = $db->f("allowed_rate");
			if($allowed_rate) {
				$rating_float = $db->f("rating");
				$rating_int = round($rating_float, 0);
				if ($rating_int) {
					$rating_alt = $rating_float;
					$rating_image = "rating_" . $rating_int . ".gif";
				} else {
					$rating_alt = RATE_IT_MSG;
					$rating_image = "not_rated.gif";
				}

				$t->set_var("rating_image", $rating_image);
				$t->set_var("rating_alt", $rating_alt);
				$t->global_parse("reviews", false, false, true);
			} else {
				$t->set_var("reviews", "");
			}
			
			$t->parse("items_cols");
			$is_next_record = $db->next_record();
			if($item_number % $columns == 0)
			{
				if($is_next_record)
					$t->global_parse("delimiter", false, false, true);
				else 
					$t->set_var("delimiter", "");
				$t->parse("items_rows");
				$t->set_var("items_cols", "");
			}
		} while ($is_next_record);              	
		$t->set_var("delimiter", "");

		if($item_number % $columns != 0)
			$t->parse("items_rows");
		
		if ($total_pages > 1)
			$t->parse("search_and_navigation", false);

		$t->parse("block_body", false);
		$t->set_var("no_items", "");
	}
	else
	{
		$t->set_var("items_rows", "");
		$t->parse("no_items", false);
		$t->parse("block_body", false);
	}
	
	// show search results information
	if($is_search) {
		$found_message = str_replace("{found_records}", $total_records, FOUND_ARTICLES_MSG);
		$found_message = str_replace("{search_string}", htmlspecialchars($search_string), $found_message);
		$t->set_var("FOUND_ARTICLES_MSG", $found_message);
		$t->parse("search_results", false);
		$t->parse("search_and_navigation", false);
		$t->parse("block_body", false);
	} 

	if ($total_records > 0 || $is_search) {
		$t->parse($block_name, true);
	}

}

?>