<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  block_forum_list.php                                     ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function forum_list($block_name) 
{
	global $t, $db, $table_prefix;
	global $datetime_show_format;

	$t->set_file("block_body", "block_forum_list.html");

	$t->set_var("FORUM_NAME_COLUMN",      FORUM_NAME_COLUMN);
	$t->set_var("FORUM_TOPICS_COLUMN",    FORUM_TOPICS_COLUMN);
	$t->set_var("FORUM_REPLIES_COLUMN",   FORUM_REPLIES_COLUMN);
	$t->set_var("FORUM_LAST_POST_COLUMN", FORUM_LAST_POST_COLUMN);
	$t->set_var("FORUM_MODERATORS_MSG",   FORUM_MODERATORS_MSG);
	$t->set_var("NO_FORUMS_MSG",          NO_FORUMS_MSG);

	$t->set_var("forum_categories_href", "forums.php");
	$t->set_var("register_href", "user_profile.php");
	$t->set_var("home_page_href", "user_home.php");
	$t->set_var("my_topics_href", "forum.php?u=1");

	$user_id = get_session("session_user_id");		
	$category_id = get_param("category_id");
	$sql  = " SELECT * FROM " . $table_prefix . "forum_categories fc, ". $table_prefix ."forum_list fl ";
	$sql .= " WHERE fc.category_id=fl.category_id AND fc.allowed_view > 0 ";
	if (strlen($user_id)) {
		$sql .= " AND fl.allowed_view IN (1,2) ";
	} else {
		$sql .= " AND fl.allowed_view=1 ";
	}
	if ($category_id) { 
		$sql .= " AND fc.category_id=" . $db->tosql($category_id, INTEGER);
	}
	$sql .= " ORDER BY fc.category_order, fc.category_id, fl.forum_order ";
	$db->query($sql);
	$forums = array(); $f = 0;
	while ($db->next_record()) {
		$forums[$f]["category_id"] = $db->f("category_id");
		$forums[$f]["category_name"] = $db->f("category_name");
		$forums[$f]["forum_id"] = $db->f("forum_id");
		$forums[$f]["forum_name"] = $db->f("forum_name");
		$forums[$f]["small_image"] = $db->f("small_image");
		$forums[$f]["short_description"] = $db->f("short_description");
		$forums[$f]["last_post_added"] = $db->f("last_post_added", DATETIME);
		$forums[$f]["threads_number"] = $db->f("threads_number");
		$forums[$f]["messages_number"] = $db->f("messages_number");
		$f++;
	}

		if ($f > 0) {
			$last_category_id = $forums[0]["category_id"];
			$last_category_name = $forums[0]["category_name"];
			for ($i = 0; $i < $f; $i++) {
				$current_category_id = $forums[$i]["category_id"];
				$current_category_name = $forums[$i]["category_name"];
				$current_forum_id = $forums[$i]["forum_id"];
				$forum_name = $forums[$i]["forum_name"];
				$small_image = $forums[$i]["small_image"];
				$short_description = $forums[$i]["short_description"];
				$last_post_added = $forums[$i]["last_post_added"];
				$threads_number = $forums[$i]["threads_number"];
				$messages_number = $forums[$i]["messages_number"];
				if ($last_category_id != $current_category_id) {
					$t->set_var("category_href", "forums.php?category_id=" . $last_category_id);
					$t->set_var("cat_name", $last_category_name);
					$t->parse("categories", true);
					$t->set_var("forums", "");
				}
				$t->set_var("forum_name", $forum_name);
				if (strlen($small_image)) {
					if (preg_match("/^http\:\/\//", $small_image)) {
						$image_size = "";
					} else {
						$image_size = @GetImageSize($small_image);
					}
					if (is_array($image_size)) {
						$t->set_var("image_size", $image_size[3]);
					} else {
						$t->set_var("image_size", "");
					}

					$t->set_var("small_image", $small_image);
					$t->parse("small_image_block", false);
				} else {
					$t->set_var("small_image_block", "");
				}
				
				$t->set_var("last_post", va_date($datetime_show_format, $last_post_added));
				$t->set_var("threads_number", $threads_number);
				$t->set_var("messages_number", $messages_number);
				$t->set_var("short_description", $short_description);
				$t->set_var("forum_href", "forum.php?forum_id=" . $current_forum_id . "&category_id=" . $current_category_id);

				// check moderators
				$moderators = "";
				$sql  = " SELECT a.admin_name FROM " . $table_prefix . "admins a, " . $table_prefix . "forum_moderators fm ";
				$sql .= " WHERE a.admin_id=fm.admin_id ";
				$sql .= " AND fm.forum_id=" . $db->tosql($current_forum_id, INTEGER);
				$db->query($sql);
				while ($db->next_record()) {
					if ($moderators) { $moderators .= ", "; }
					$moderators .= $db->f("admin_name");
				}	
				if ($moderators) {
					$t->set_var("moderators", $moderators);
					$t->parse("moderators_block", false);
				} else {
					$t->set_var("moderators_block", "");
				}


				$t->parse("forums", true);
	  
				$last_category_id   = $current_category_id;
				$last_category_name = $current_category_name;
			} while($db->next_record());

			$t->set_var("category_href", "forums.php?category_id=" . $last_category_id);
			$t->set_var("cat_name", $last_category_name);
			$t->parse("categories", true);
			$t->set_var("no_forums", "");
			$t->set_var("forums", "");

		} else {
			$t->parse("no_forums", false);
			$t->set_var("categories", "");
		}
		$t->parse("block_body", false);
		$t->parse($block_name, true);

}

?>