<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  block_products_recommended.php                           ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function products_recommended($block_name)
{
	global $t, $db, $table_prefix;
	global $settings, $page_settings, $current_page, $restrict_products_images;
	global $language_code;
	global $currency_left, $currency_right, $currency_rate;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$user_id = get_session("session_user_id");
	$user_name = get_session("session_user_name");
	$user_type_id = get_session("session_user_type_id");
	if (!strlen($user_id)) {
		return;
	}

	$discount_type = get_session("session_discount_type");
	$discount_amount = get_session("session_discount_amount");
	$display_products = get_setting_value($settings, "display_products", 0);
	$product_no_image = get_setting_value($settings, "product_no_image", "");

	$item_id = get_param("item_id");
	$t->set_file("block_body", "block_products_recommended.html");
	$t->set_var("product_details_href", "product_details.php");
	$recommended_title = str_replace("{user_name}", $user_name, PRODUCTS_RECOMMENDED_TITLE);
	$t->set_var("PRODUCTS_RECOMMENDED_TITLE", $recommended_title);
	$t->set_var("PROD_AVAILABILITY_MSG", PROD_AVAILABILITY_MSG);
	$t->set_var("MORE_MSG",               MORE_MSG);
	$t->set_var("READ_MORE_MSG",          READ_MORE_MSG);
	$t->set_var("CLICK_HERE_MSG",         CLICK_HERE_MSG);
	$t->set_var("PRICE_MSG",              PRICE_MSG);
	$t->set_var("OUR_PRICE_MSG",          OUR_PRICE_MSG);

	$items_ids = "";
	$sql  = " SELECT oi.item_id ";
	$sql .= " FROM " . $table_prefix . "orders_items oi, " . $table_prefix . "orders o ";
	$sql .= " WHERE o.order_id=oi.order_id ";
	$sql .= " AND o.user_id=" . $db->tosql($user_id, INTEGER);
	$sql .= " GROUP BY oi.item_id ";
	$db->query($sql);
	while ($db->next_record()) {
		$item_id = $db->f("item_id");
		if (strlen($items_ids)) { $items_ids .= ",";	}
		$items_ids .= $item_id;
	}
	if (!strlen($items_ids)) {
		return;
	}

	// set up variables for navigator
	$total_records = 0; 
	$recommended = array(); $recom_ids = "";

	// get related items first
	$sql  = " SELECT i.item_id ";
	$sql .= " FROM " . $table_prefix . "items i, " . $table_prefix . "items_related ir ";
	$sql .= " WHERE i.item_id=ir.related_id ";
	$sql .= " AND ir.item_id IN (" . $items_ids . ")";
	$sql .= " AND ir.related_id NOT IN (" . $items_ids . ")";
	$sql .= " AND i.is_showing=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0)";
	$sql .= " AND (i.language_code IS NULL OR i.language_code='' OR i.language_code=" . $db->tosql($language_code, TEXT) . ")";
	$sql .= " GROUP BY i.item_id ";
	$db->query($sql);
	while ($db->next_record()) {
		$total_records++;
		$item_id = $db->f("item_id");
		$recommended[] = $item_id;
	}

	// get accessories
	$sql  = " SELECT i.item_id ";
	$sql .= " FROM " . $table_prefix . "items i, " . $table_prefix . "items_accessories ia ";
	$sql .= " WHERE i.item_id=ia.accessory_id ";
	$sql .= " AND ia.item_id IN (" . $items_ids . ")";
	$sql .= " AND ia.accessory_id NOT IN (" . $items_ids . ")";
	$sql .= " AND i.is_showing=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0)";
	$sql .= " AND (i.language_code IS NULL OR i.language_code='' OR i.language_code=" . $db->tosql($language_code, TEXT) . ")";
	$sql .= " GROUP BY i.item_id ";
	$db->query($sql);
	while ($db->next_record()) {
		$item_id = $db->f("item_id");
		if (!in_array($item_id, $recommended)) {
			$total_records++;
			$recommended[] = $item_id;
		}
	}

	// check if recommended products exists
	if (sizeof($recommended) > 0) {
		$recom_ids = join(",", $recommended);
	} else {
		return;
	}

	// prepare navigator for recommended products
	$records_per_page = get_setting_value($page_settings, "prod_recom_per_page", 10);
	$pages_number = 5;
	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", $current_page);
	$page_number = $n->set_navigator("pr_navigator", "rpage", SIMPLE, $pages_number, $records_per_page, $total_records, false);

	$sql  = " SELECT i.item_id, i.item_type_id, i.item_name,i.short_description, i.small_image, i.small_image_alt, ";
	$sql .= " i.buying_price, i.price, i.properties_price, i.sales_price, i.is_sales, i.tax_free, ";
	$sql .= " ip.price AS user_price, ip.discount_action AS user_price_action, ";
	$sql .= " i.stock_level, st_in.shipping_time_desc AS in_stock_message, st_out.shipping_time_desc AS out_stock_message ";
	$sql .= " FROM ((((" . $table_prefix . "items i ";
	$sql .= " LEFT JOIN " . $table_prefix . "items_prices ip ON (i.item_id=ip.item_id AND ip.min_quantity=1 AND ip.user_type_id=" . $db->tosql($user_type_id, INTEGER) . ")) ";
	$sql .= " LEFT JOIN " . $table_prefix . "manufacturers m ON i.manufacturer_id=m.manufacturer_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_in ON i.shipping_in_stock=st_in.shipping_time_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_out ON i.shipping_out_stock=st_out.shipping_time_id) ";
	$sql .= " WHERE i.item_id IN (" . $recom_ids . ")";
	//$sql .= " ORDER BY related_order ";
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$db->query($sql);
	if($db->next_record())
	{
		$pr_columns = get_setting_value($page_settings, "prod_recom_cols", 1);
		$t->set_var("pr_column", (100 / $pr_columns) . "%");
		$pr_number = 0;
		do
		{
			$pr_number++;
			$item_id = $db->f("item_id");
			$item_type_id = $db->f("item_type_id");
			$item_name = get_translation($db->f("item_name"));
			$short_description = get_translation($db->f("short_description"));

			$t->set_var("item_id", $item_id);
			$t->set_var("item_name", $item_name);
			$t->set_var("short_description", $short_description);
			$t->set_var("pr_tax_price", "");
			$t->set_var("pr_tax_sales", "");

			$stock_level = $db->f("stock_level");
			if ($stock_level > 0) {
				$shipping_time_desc = $db->f("in_stock_message");
			} else {
				$shipping_time_desc = $db->f("out_stock_message");
			}
			if(strlen($shipping_time_desc)) {
				$t->set_var("shipping_time_desc", $shipping_time_desc);
				$t->parse("pr_availability", false);
			} else {
				$t->set_var("pr_availability", "");
			}


			if ($display_products != 2 || strlen($user_id)) {
				$price = $db->f("price");
				$is_sales = $db->f("is_sales");
				$sales_price = $db->f("sales_price");
				$buying_price = $db->f("buying_price");
				$user_price = $db->f("user_price");
				$user_price_action = $db->f("user_price_action");
				$properties_price = $db->f("properties_price");
				if ($user_price > 0 && ($user_price_action > 0 || !$discount_type)) {
					if ($is_sales && $sales_price > 0) {
						$sales_price = $user_price;
					} else {
						$price = $user_price;
					}
				}

				$tax_free = $db->f("tax_free");
				if ($user_price_action != 1) {
					if ($discount_type == 1 || $discount_type == 3) {
						$price -= round(($price * $discount_amount) / 100, 2);
						$sales_price -= round(($sales_price * $discount_amount) / 100, 2);
					} else if ($discount_type == 2) {
						$price -= round($discount_amount, 2);
						$sales_price -= round($discount_amount, 2);
					} else if ($discount_type == 4) {
						$price -= round((($price - $buying_price) * $discount_amount) / 100, 2);
						$sales_price -= round((($sales_price - $buying_price) * $discount_amount) / 100, 2);
					}
				}
				// add properties and components prices
				$price += $properties_price;
				$sales_price += $properties_price;

				$price = $price * $currency_rate;
				$sales_price = $sales_price * $currency_rate;
		  
				if($sales_price > 0 && $sales_price != $price && $is_sales)
				{
					set_tax_price($item_id, $item_type_id, $price, $sales_price, $tax_free, "pr_price", "pr_sales_price", "pr_tax_sales", false);

					$t->set_var("pr_price_class", "realprice");
					$t->sparse("pr_price_block", false);
					$t->sparse("pr_sales", false);
				}
				else
				{
					set_tax_price($item_id, $item_type_id, $price, 0, $tax_free, "pr_price", "", "pr_tax_price", false);

					$t->set_var("pr_price_class", "ourprice");
					$t->sparse("pr_price_block", false);
					$t->set_var("pr_sales", "");
				}
			}

			$small_image = $db->f("small_image");
			if (!$small_image) {
				$small_image = $product_no_image;
			}
			$small_image_alt = $db->f("small_image_alt");
			if($small_image)
			{
				if (preg_match("/^http\:\/\//", $small_image)) {
					$image_size = "";
				} else {
	        $image_size = @GetImageSize($small_image);
					if (isset($restrict_products_images) && $restrict_products_images) { $small_image = "image_show.php?item_id=".$item_id."&type=small"; }
				}
				if (!strlen($small_image_alt)) { $small_image_alt = $item_name; }
        $t->set_var("alt", htmlspecialchars($small_image_alt));
        $t->set_var("src", htmlspecialchars($small_image));
				if(is_array($image_size))
				{
	        $t->set_var("width", "width=\"" . $image_size[0] . "\"");
  	      $t->set_var("height", "height=\"" . $image_size[1] . "\"");
				}
				else
				{
	        $t->set_var("width", "");
  	      $t->set_var("height", "");
				}
				$t->sparse("pr_small_image", false);
			}
			else
			{
				$t->set_var("pr_small_image", "");
			}

			$t->parse("pr_cols");
			if($pr_number % $pr_columns == 0)
			{
				$t->parse("pr_rows");
				$t->set_var("pr_cols", "");
			}
			
		} while ($db->next_record());              	

		if($pr_number % $pr_columns != 0)
			$t->parse("pr_rows");

		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>