<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  forum.php                                                ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./includes/common.php");
	include_once ("./messages/".$language_code."/forum_messages.php");
	include_once ("./includes/navigator.php");
	include_once ("./includes/tree.php");
	include_once ("./includes/date_functions.php");
	include_once ("./includes/sorter.php");
	
	// include blocks
	include_once ("./block_custom.php");
	include_once ("./block_banners.php");

	$display_forums = get_setting_value($settings, "display_forums", 0);
	if ($display_forums == 1) {
		// user need to be logged in before viewing forum
		check_user_session();
	}
	$user_id = get_session("session_user_id");		
	$page_settings = va_page_settings("forum_topics", 0);
	$currency = get_currency();
	$category_id = get_param("category_id");
	$forum_id = get_param("forum_id");
	$sf = get_param("sf");
	$sw = trim(get_param("sw"));
	$u = get_param("u");
	if (!$forum_id && preg_match("/^f(\d+)$/i", $sf, $match)) {
		$forum_id = $match[1];
	} else if (!$category_id && preg_match("/^c(\d+)$/i", $sf, $match)) {
		$category_id = $match[1];
	}

	// if there are no parameters redirect to forums list
	if (!$forum_id && !$category_id && !$sf && !$sw && !$u) {
		header("Location: forums.php");
		exit;
	}

	$html_title = ""; $meta_description = ""; $meta_keywords = ""; 
	// retrieve info about current category
	if ($forum_id) {
		$sql  = " SELECT * FROM " . $table_prefix . "forum_list fl ";
		$sql .= " WHERE fl.forum_id=" . $db->tosql($forum_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$category_name = get_translation($db->f("forum_name"));
			$short_description = get_translation($db->f("short_description"));
			$full_description = get_translation($db->f("full_description"));
			$allowed_view = $db->f("allowed_view");
			$allowed_view_topics = $db->f("allowed_view_topics");
			$allowed_post_topics = $db->f("allowed_post_topics");
    
			$html_title = $category_name; 
			if (strlen($short_description)) {
				$meta_description = $short_description;
			} else if (strlen($full_description)) {
				$meta_description = $full_description;
			}		
		} else {
			$allowed_view = 0; $allowed_view_topics = 0;
		}

		if (!$allowed_view || !$allowed_view_topics) {
			header ("Location: forums.php");
			exit;
		} else if ($allowed_view == 2 || $allowed_view_topics == 2) {
			// user need to be logged in before viewing forum
			check_user_session();
		}
	} else {
		$allowed_post_topics = 0;
	}

	$t = new VA_Template($settings["templates_dir"]);
	$t->set_file("main","forum.html");
	$t->set_var("FORUM_TITLE", FORUM_TITLE);
	$t->set_var("ALL_FORUM_TOPICS_MSG", ALL_FORUM_TOPICS_MSG);
	$t->set_var("current_href", "forum.php");
	include_once ("./header.php");
	if(is_array($page_settings)) {
		foreach($page_settings as $setting_name => $setting_value)
		{
			if ($setting_name == "top_products_block") {
				include_once ("./block_top_products.php");
				top_products($setting_value);
			} else if ($setting_name == "products_top_sellers") {
				include_once ("./block_products_top_sellers.php");
				products_top_sellers($setting_value);
			} else if ($setting_name == "search_block") {
				include_once ("./block_search.php");
				search_form($setting_value);
			} else if ($setting_name == "products_recently_viewed") {
				include_once ("./block_products_recently.php");
				products_recently_viewed($setting_value);
			} else if ($setting_name == "login_block") {
				login_form($setting_value);
			} else if ($setting_name == "cart_block") {
				include_once ("./block_cart.php");
				small_cart($setting_value);
			} else if ($setting_name == "subscribe_block") {
				include_once ("./block_subscribe.php");
				subscribe_form($setting_value);
			} else if ($setting_name == "sms_test_block") {
				include_once ("./block_sms_test.php");
				sms_test_form($setting_value);
			} else if ($setting_name == "poll_block") {
				include_once ("./block_poll.php");
				poll_form($setting_value);
			} else if ($setting_name == "language_block") {
				include_once ("./block_language.php");
				language_form($setting_value, $page_settings["language_selection"]);
			} else if ($setting_name == "currency_block") {
				include_once ("./block_currency.php");
				currency_form($setting_value);
			} else if($setting_name == "forum_search_block") {
				include_once ("./block_forum_search.php");
				forum_search($setting_value);
			} else if($setting_name == "forum_list") {
				include_once ("./block_forum_list.php");
				forum_list($setting_value);
			} else if($setting_name == "forum_topics_block") {
				include_once ("./block_forum_topics.php");
				forum_topics_show($setting_value, $allowed_post_topics);
			} else if($setting_name == "forum_breadcrumb") {
				include_once("./block_forum_breadcrumb.php");
				forum_breadcrumb($setting_value);
			} else if (preg_match("/^custom_block_/", $setting_name)) {
				custom_block($setting_value, substr($setting_name, 13));
			} else if (preg_match("/^banners_group_/", $setting_name)) {
				banners_group($setting_value, substr($setting_name, 14));
			}
		}
	}
	if(!get_setting_value($page_settings, "left_column_hide", 0)) {
		$t->set_var("left_column_width", get_setting_value($page_settings, "left_column_width", "20%"));
		$t->parse("left_column", false);
	}
	if(!get_setting_value($page_settings, "middle_column_hide", 0)) {
		$t->set_var("middle_column_width", get_setting_value($page_settings, "middle_column_width", "60%"));
		$t->parse("middle_column", false);
	}
	if(!get_setting_value($page_settings, "right_column_hide", 0)) {
		$t->set_var("right_column_width", get_setting_value($page_settings, "right_column_width", "20%"));
		$t->parse("right_column", false);
	}
	include_once ("./footer.php");

	$t->set_var("html_title", $html_title);
	$t->set_var("meta_keywords", $meta_keywords);
	$t->set_var("meta_description", get_meta_desc($meta_description));
	$t->pparse("main");
?>