<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  user_ads.php                                             ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	$includes_path = "./includes/";
	include_once ($includes_path . "/common.php");
	include_once ($includes_path . "/sorter.php");
	include_once ($includes_path . "/navigator.php");
	include_once ($includes_path . "/date_functions.php");
	include_once ($includes_path . "/record.php");

	check_user_session();

	$currency = get_currency();
	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];

  $t = new VA_Template($settings["templates_dir"]);
  $t->set_file("main","user_ads.html");
	$t->set_var("user_ads_href",  "user_ads.php");
	$t->set_var("user_ad_href",   "user_ad.php");
	$t->set_var("user_home_href", "user_home.php");
	$t->set_var("MY_ADS_MSG",     MY_ADS_MSG);
	$t->set_var("MY_ACCOUNT_MSG", MY_ACCOUNT_MSG);
	$t->set_var("NO_ADS_MSG",     NO_ADS_MSG);
	$t->set_var("EDIT_AD_MSG",    EDIT_AD_MSG);
	$t->set_var("ADD_NEW_AD_MSG", ADD_NEW_AD_MSG);
	$t->set_var("AD_STATUS_COLUMN", AD_STATUS_COLUMN);

	$s = new VA_Sorter($settings["templates_dir"], "sorter_img.html", "user_ads.php");
	$s->set_default_sorting(1, "desc");
	$s->set_sorter(AD_ID_COLUMN, "sorter_id", "1", "item_id");
	$s->set_sorter(AD_TITLE_COLUMN, "sorter_title", "2", "item_title");
	$s->set_sorter(AD_PRICE_COLUMN, "sorter_price", "3", "price");
	$s->set_sorter(AD_STATUS_COLUMN, "sorter_status", "4", "is_approved");

	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", "user_ads.php");

	include("./header.php");
	include("./footer.php");

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "ads_items WHERE user_id=" . $db->tosql(get_session("session_user_id"), INTEGER));
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;

	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$sql  = " SELECT item_id, item_title, price, is_approved, date_start, date_end ";
	$sql .= " FROM " . $table_prefix . "ads_items ";
	$sql .= " WHERE user_id=" . $db->tosql(get_session("session_user_id"), INTEGER);
	$db->query($sql . $s->order_by);
	if($db->next_record())
	{
		$t->parse("sorters", false);
		$t->set_var("no_records", "");
		do
		{
			$item_id = $db->f("item_id");
			$item_title = $db->f("item_title");
			$price = $db->f("price");
			$price = $price * $currency_rate;

			$t->set_var("item_id", $item_id);
			$t->set_var("item_title", $item_title);
			$t->set_var("price", $currency_left . number_format($price, 2) . $currency_right);

			$is_approved = $db->f("is_approved");
			$date_start = $db->f("date_start", DATETIME);
			$date_end = $db->f("date_end", DATETIME);
			$date_start_ts = mktime(0,0,0, $date_start[MONTH], $date_start[DAY], $date_start[YEAR]);
			$date_end_ts = mktime(0,0,0, $date_end[MONTH], $date_end[DAY], $date_end[YEAR]);
			$date_now_ts = time();
			if ($is_approved != 1) {
				$status = "<font color=red>".AD_NOT_APPROVED_MSG."</font>";
			} else if ($date_now_ts >= $date_start_ts && $date_now_ts < $date_end_ts) {
				$status = "<font color=blue>".AD_RUNNING_MSG."</font>";
			} else if ($date_start_ts == $date_end_ts) {
				$status = "<font color=silver>".AD_CLOSED_MSG."</font>";
			} else if ($date_now_ts >= $date_end_ts) {
				$status = "<font color=silver>".AD_EXPIRED_MSG."</font>";
			}	else if ($date_now_ts < $date_start_ts) {
				$status = AD_NOT_STARTED_MSG;
			}
			$t->set_var("status", $status);


			$t->parse("records", true);
		} while($db->next_record());
	}
	else
	{
		$t->set_var("sorters", "");
		$t->set_var("records", "");
		$t->set_var("navigator", "");
		$t->parse("no_records", false);
	}

	$type_index = 0;
	$sql  = " SELECT type_id, type_name ";
	$sql .= " FROM " . $table_prefix . "ads_types ";
	$db->query($sql);
	while ($db->next_record()) {
		$type_index++;
		$type_id = $db->f("type_id");
		$type_name = $db->f("type_name");
		$delimiter = ($type_index > 1) ? " | " : "";

		$t->set_var("type_id", $type_id);
		$t->set_var("type_name", $type_name);
		$t->set_var("delimiter", $delimiter);

		$t->parse("ads_types", true);
	}


	$t->pparse("main");

?>